script_author("Naito")
script_name("Crosshair Settings")
script_version("1.0")

local encoding = require 'encoding'
encoding.default = 'CP1251'
local u8 = encoding.UTF8

local ffi = require 'ffi'
local hook = require('monethook')
local imgui = require 'mimgui'
local faicons = require('fAwesome6')

local cf = (function ()local a='/'if MONET_VERSION==nil then a='\\'end;local function b(c,d)d=d or{}if c==nil then return nil end;if d[c]then return d[c]end;local e;if type(c)=='table'then e={}d[c]=e;for f,g in next,c,nil do e[b(f,d)]=b(g,d)end;setmetatable(e,b(getmetatable(c),d))else e=c end;return e end;local function h(i,j)for f,g in next,j,nil do if i[f]==nil then i[b(f)]=b(g)else if type(g)=='table'and type(i[f])=='table'then h(i[f],g)end end end end;local function k(l,m,n)local l=l or{}local n=n or'.json'local m=m or script.this.filename..n;m:gsub('\\',a)if MONET_VERSION~=nil then m:gsub('moonloader/','monetloader/')end;local o=getWorkingDirectory()..a..'config'..a..m..n;local p=getWorkingDirectory()..a..'config'..a..m;local q=m;local r=io.open(o,'r')if not r then r=io.open(p,'r')end;if not r then r=io.open(q,'r')end;if r then local s=r:read('*a')if#s==0 then r:close()return b(l)end;local t,u=pcall(decodeJson,s)r:close()if not t or not u then if not t then print('jsoncfg: failed to decode json, error:',u)end;return b(l)end;h(u,l)return u else return b(l)end end;local function v(w,m,n)local n=n or'.json'local m=m or script.this.filename..n;m:gsub('\\',a)if MONET_VERSION~=nil then m:gsub('moonloader/','monetloader/')end;local x=getWorkingDirectory()..a..'config'..a;if m:find(a,1,true)~=nil then local y=m:match('.*'..a)createDirectory(y)x=m elseif m:match('%'..n..'$')~=nil then createDirectory(x)x=x..m else createDirectory(x)x=x..m..n end;local r,z=io.open(x,'w')if r then local t,A=pcall(encodeJson,w)if t then r:write(A)else print('jsoncfg: failed to encode json, error:',A)end;r:close()return t else print('jsoncfg: failed to open file, error:',z)return false end end;return{load=k,save=v}end)()

---@type table
local cfg = cf.load({
    locale = "es",
    sensitivity = 0,
    aspectratio = 0,
    crosshair_pos_x = 0.518,
    crosshair_pos_y = 0.465
}, "Crosshair_Settings")
cfg.sensitivity = cfg.sensitivity / 1000000

local function save()
    cfg.sensitivity = cfg.sensitivity * 1000000
    cf.save(cfg, "Crosshair_Settings")
    cfg.sensitivity = cfg.sensitivity / 1000000
end

local locales = {
    es = {
        language_switch = "English",
        save_settings = "Guardar Configuracion",
        reset_settings = "Restablecer Configuracion",
        auto = "Auto",
        sensitivity = "Sensibilidad",
        aspectratio = "Relacion de Aspecto",
        crosshair_position = "Posicion de la Mira",
        position_x = "Posicion X",
        position_y = "Posicion Y",
        settings_saved = "Configuracion guardada exitosamente!",
        settings_reset = "Configuracion restablecida por defecto!"
    },
    en = {
        language_switch = "Espanol",
        save_settings = "Save Settings",
        reset_settings = "Reset Settings",
        auto = "Auto",
        sensitivity = "Sensitivity",
        aspectratio = "Aspect Ratio",
        crosshair_position = "Crosshair Position",
        position_x = "Position X",
        position_y = "Position Y",
        settings_saved = "Settings saved successfully!",
        settings_reset = "Settings reset to default!"
    },
}

local colors = {
    background = imgui.ImVec4(0.10, 0.10, 0.10, 0.95),
    header = imgui.ImVec4(0.15, 0.15, 0.15, 1.00),
    button = imgui.ImVec4(0.20, 0.20, 0.20, 1.00),
    button_hover = imgui.ImVec4(0.30, 0.30, 0.30, 1.00),
    button_active = imgui.ImVec4(0.15, 0.15, 0.15, 1.00),
    frame = imgui.ImVec4(0.18, 0.18, 0.18, 1.00),
    frame_hover = imgui.ImVec4(0.25, 0.25, 0.25, 1.00),
    frame_active = imgui.ImVec4(0.30, 0.30, 0.30, 1.00),
    text = imgui.ImVec4(1.00, 1.00, 1.00, 1.00),
    text_disabled = imgui.ImVec4(0.50, 0.50, 0.50, 1.00),
    accent = imgui.ImVec4(0.75, 0.75, 0.75, 1.00),
    success = imgui.ImVec4(0.20, 0.80, 0.20, 1.00),
    success_hover = imgui.ImVec4(0.30, 0.90, 0.30, 1.00),
    success_active = imgui.ImVec4(0.10, 0.70, 0.10, 1.00),
    warning = imgui.ImVec4(0.80, 0.60, 0.20, 1.00),
    warning_hover = imgui.ImVec4(0.90, 0.70, 0.30, 1.00),
    warning_active = imgui.ImVec4(0.70, 0.50, 0.10, 1.00),
    border = imgui.ImVec4(0.35, 0.35, 0.35, 1.00),
    separator = imgui.ImVec4(0.45, 0.45, 0.45, 1.00),
    purple = imgui.ImVec4(0.75, 0.40, 0.90, 1.00)
}

function msg(text)
    sampAddChatMessage('{FFFFFF}[Crosshair Settings] '..text, -1)
end

function applyModernTheme()
    local style = imgui.GetStyle()
    
    style.Colors[imgui.Col.WindowBg] = colors.background
    style.Colors[imgui.Col.ChildBg] = imgui.ImVec4(0.12, 0.12, 0.12, 1.00)
    style.Colors[imgui.Col.PopupBg] = colors.background
    style.Colors[imgui.Col.Border] = colors.border
    style.Colors[imgui.Col.BorderShadow] = imgui.ImVec4(0.00, 0.00, 0.00, 0.00)
    style.Colors[imgui.Col.FrameBg] = colors.frame
    style.Colors[imgui.Col.FrameBgHovered] = colors.frame_hover
    style.Colors[imgui.Col.FrameBgActive] = colors.frame_active
    style.Colors[imgui.Col.TitleBg] = imgui.ImVec4(0.08, 0.08, 0.08, 1.00)
    style.Colors[imgui.Col.TitleBgActive] = imgui.ImVec4(0.12, 0.12, 0.12, 1.00)
    style.Colors[imgui.Col.TitleBgCollapsed] = imgui.ImVec4(0.00, 0.00, 0.00, 0.51)
    style.Colors[imgui.Col.Button] = colors.button
    style.Colors[imgui.Col.ButtonHovered] = colors.button_hover
    style.Colors[imgui.Col.ButtonActive] = colors.button_active
    style.Colors[imgui.Col.Text] = colors.text
    style.Colors[imgui.Col.TextDisabled] = colors.text_disabled
    
    style.WindowRounding = 12.0
    style.ChildRounding = 8.0
    style.FrameRounding = 6.0
    style.PopupRounding = 6.0
    style.ScrollbarRounding = 6.0
    style.GrabRounding = 6.0
    style.TabRounding = 6.0
    style.WindowBorderSize = 0.0
    style.ChildBorderSize = 1.0
    style.PopupBorderSize = 1.0
    style.FrameBorderSize = 0.0
    
    style.WindowPadding = imgui.ImVec2(20, 20)
    style.FramePadding = imgui.ImVec2(12, 8)
    style.ItemSpacing = imgui.ImVec2(12, 12)
    style.ItemInnerSpacing = imgui.ImVec2(8, 8)
    style.IndentSpacing = 30.0
end

ffi.cdef[[
    typedef struct RwRect RwRect;
    typedef struct RwCamera RwCamera;

    void _Z10CameraSizeP8RwCameraP6RwRectff(RwCamera *camera, RwRect *rect, float unk, float aspect);
    float AIMWEAPON_STICK_SENS;

    float _ZN7CCamera22m_f3rdPersonCHairMultXE;
    float _ZN7CCamera22m_f3rdPersonCHairMultYE;
    void _ZN4CHud14DrawCrossHairsEv();
]]
local gta = ffi.load('GTASA')

local function setSensitivity(value)
    gta.AIMWEAPON_STICK_SENS = 0.001 + value / 3000.0
end

local MDS = MONET_DPI_SCALE
local window = imgui.new.bool(false)
local m_sens = imgui.new.float(cfg.sensitivity)
local m_aspectratio = imgui.new.int(cfg.aspectratio)

local crosshair_pos_x = imgui.new.float(cfg.crosshair_pos_x)
local crosshair_pos_y = imgui.new.float(cfg.crosshair_pos_y)

local aspectratio_list = {
    u8(locales[cfg.locale].auto),
    "3:2",
    "4:3",
    "5:4",
    "16:9",
    "16:10",
    "21:9",
    "32:9",
}
local aspectratio_nums = {
    0.0,
    3.0 / 2.0,
    4.0 / 3.0,
    5.0 / 4.0,
    16.0 / 9.0,
    16.0 / 10.0,
    21.0 / 9.0,
    32.0 / 9.0,
}
local m_aspectratio_list = imgui.new['const char*'][#aspectratio_list](aspectratio_list)

function aspectHook(camera, rect, unk, aspect)
    if cfg.aspectratio == nil or cfg.aspectratio == 0 then
        return aspectHook(camera, rect, unk, aspect)
    end
    return aspectHook(camera, rect, unk, aspectratio_nums[cfg.aspectratio+1])
end

function drawCrosshairHook()
    local save1 = gta._ZN7CCamera22m_f3rdPersonCHairMultXE
    local save2 = gta._ZN7CCamera22m_f3rdPersonCHairMultYE

    gta._ZN7CCamera22m_f3rdPersonCHairMultXE = cfg.crosshair_pos_x
    gta._ZN7CCamera22m_f3rdPersonCHairMultYE = cfg.crosshair_pos_y

    local r = drawCrosshairHook()

    gta._ZN7CCamera22m_f3rdPersonCHairMultXE = save1
    gta._ZN7CCamera22m_f3rdPersonCHairMultYE = save2

    return r
end

aspectHook = hook.new('void(*)(RwCamera *camera, RwRect *rect, float unk, float aspect)', aspectHook, ffi.cast('uintptr_t', ffi.cast('void*', gta._Z10CameraSizeP8RwCameraP6RwRectff)))
drawCrosshairHook = hook.new('void(*)()', drawCrosshairHook, ffi.cast('uintptr_t', ffi.cast('void*', gta._ZN4CHud14DrawCrossHairsEv)))

imgui.OnInitialize(function()
    imgui.GetIO().IniFilename = nil
    imgui.GetStyle():ScaleAllSizes(MDS)
    
    local config = imgui.ImFontConfig()
    config.MergeMode = true
    config.PixelSnapH = true
    iconRanges = imgui.new.ImWchar[3](faicons.min_range, faicons.max_range, 0)
    imgui.GetIO().Fonts:AddFontFromMemoryCompressedBase85TTF(faicons.get_font_data_base85('solid'), 14, config, iconRanges)
end)

imgui.OnFrame(function ()
    return window[0]
end, function()
    applyModernTheme()
    
    local resX, resY = getScreenResolution()
    imgui.SetNextWindowPos(imgui.ImVec2(resX/2, resY/2), imgui.Cond.FirstUseEver, imgui.ImVec2(0.5, 0.5))
    imgui.SetNextWindowSize(imgui.ImVec2(500 * MDS, 600 * MDS), imgui.Cond.FirstUseEver)
    
    if imgui.Begin(faicons("gear") .. u8" Crosshair Settings", window, imgui.WindowFlags.NoCollapse) then
        
        imgui.TextColored(imgui.ImVec4(0.9, 0.9, 0.9, 1.0), faicons("sliders") .. u8"  CONFIGURACION DE MIRA")
        imgui.SameLine()
        imgui.SetCursorPosX(imgui.GetWindowWidth() - 100)
        imgui.TextColored(colors.text_disabled, u8"v1.0")
        imgui.SetCursorPosX((imgui.GetWindowWidth() - 80) / 2)
        imgui.TextColored(colors.text_disabled, u8"By Naito")
        
        imgui.Spacing()
        imgui.Separator()
        imgui.Spacing()
        
        imgui.TextColored(colors.accent, faicons("sliders") .. u8" " .. locales[cfg.locale].sensitivity)
        imgui.SetNextItemWidth(imgui.GetWindowWidth() - 40)
        if imgui.SliderFloat("##sens", m_sens, 0.0, 100.0, "%.1f") then
            cfg.sensitivity = m_sens[0]
            setSensitivity(cfg.sensitivity)
        end
        
        imgui.Spacing()
        
        imgui.TextColored(colors.accent, faicons("tv") .. u8" " .. locales[cfg.locale].aspectratio)
        imgui.SetNextItemWidth(imgui.GetWindowWidth() - 40)
        if imgui.Combo("##aspect", m_aspectratio, m_aspectratio_list, #aspectratio_list) then
            cfg.aspectratio = m_aspectratio[0]
        end
        
        imgui.Spacing()
        imgui.Separator()
        imgui.Spacing()
        
        imgui.TextColored(colors.accent, faicons("crosshairs") .. u8" " .. locales[cfg.locale].crosshair_position)
        
        imgui.Text(u8"  " .. locales[cfg.locale].position_x .. ":")
        imgui.SetNextItemWidth(imgui.GetWindowWidth() - 40)
        if imgui.SliderFloat("##pos_x", crosshair_pos_x, 0.0, 1.0, "%.3f") then
            cfg.crosshair_pos_x = crosshair_pos_x[0]
        end
        
        imgui.Text(u8"  " .. locales[cfg.locale].position_y .. ":")
        imgui.SetNextItemWidth(imgui.GetWindowWidth() - 40)
        if imgui.SliderFloat("##pos_y", crosshair_pos_y, 0.0, 1.0, "%.3f") then
            cfg.crosshair_pos_y = crosshair_pos_y[0]
        end
        
        imgui.Spacing()
        imgui.Separator()
        imgui.Spacing()
        
        local button_width = (imgui.GetWindowWidth() - 60) / 2
        
        imgui.PushStyleColor(imgui.Col.Button, colors.purple)
        imgui.PushStyleColor(imgui.Col.ButtonHovered, imgui.ImVec4(0.85, 0.50, 1.00, 1.00))
        imgui.PushStyleColor(imgui.Col.ButtonActive, imgui.ImVec4(0.65, 0.30, 0.80, 1.00))
        
        if imgui.Button(u8" " .. locales[cfg.locale].language_switch, imgui.ImVec2(button_width, 40)) then
            if cfg.locale == "es" then
                cfg.locale = "en"
            else
                cfg.locale = "es"
            end
        end
        imgui.PopStyleColor(3)
        
        imgui.SameLine()
        
        imgui.PushStyleColor(imgui.Col.Button, colors.warning)
        imgui.PushStyleColor(imgui.Col.ButtonHovered, colors.warning_hover)
        imgui.PushStyleColor(imgui.Col.ButtonActive, colors.warning_active)
        
        if imgui.Button(u8" " .. locales[cfg.locale].reset_settings, imgui.ImVec2(button_width, 40)) then
            cfg.sensitivity = 0
            cfg.aspectratio = 0
            cfg.crosshair_pos_x = 0.518
            cfg.crosshair_pos_y = 0.465
            
            m_sens[0] = cfg.sensitivity
            m_aspectratio[0] = cfg.aspectratio
            crosshair_pos_x[0] = cfg.crosshair_pos_x
            crosshair_pos_y[0] = cfg.crosshair_pos_y
            
            setSensitivity(cfg.sensitivity)
            msg(locales[cfg.locale].settings_reset)
        end
        imgui.PopStyleColor(3)
        
        imgui.Spacing()
        
        imgui.SetCursorPosX((imgui.GetWindowWidth() - 350) / 2)
        imgui.PushStyleColor(imgui.Col.Button, colors.success)
        imgui.PushStyleColor(imgui.Col.ButtonHovered, colors.success_hover)
        imgui.PushStyleColor(imgui.Col.ButtonActive, colors.success_active)
        
        if imgui.Button(u8" " .. locales[cfg.locale].save_settings, imgui.ImVec2(350, 50)) then
            save()
            msg(locales[cfg.locale].settings_saved)
        end
        imgui.PopStyleColor(3)
        
        imgui.Spacing()
        imgui.Separator()
        imgui.Spacing()
        
        imgui.SetCursorPosX((imgui.GetWindowWidth() - imgui.CalcTextSize(u8"MST Community").x) / 2)
        imgui.TextColored(colors.purple, u8"MST Community")
        
    end
    imgui.End()
end)

sampRegisterChatCommand("ms", function()
    window[0] = not window[0]
end)

function GetMiddleButtonX(count)
    local width = imgui.GetWindowContentRegionWidth()
    local space = imgui.GetStyle().ItemSpacing.x
    return count == 1 and width or width / count - ((space * (count - 1)) / count)
end

function main()
    if cfg.sensitivity ~= 0 then setSensitivity(cfg.sensitivity) end

    while true do
        wait(0)
    end
end

function onScriptTerminate(script, quitGame)
    if script == thisScript() then
        save()
    end
end